# !usr/bin/env python
# -*- coding: utf-8 -*-
#

# this file was autogenerated with sqlacodegen and then adapted for sdssdb
# flake8: noqa=E501,E741


from sqlalchemy.ext.declarative import AbstractConcreteBase, declared_attr
from sqlalchemy import BigInteger, Boolean, Column, Float, Integer, SmallInteger, Text, text

from sdssdb.sqlalchemy.sdss5db import SDSS5dbBase, database


SCHEMA = 'vizdb'


class Base(AbstractConcreteBase, SDSS5dbBase):
    __abstract__ = True
    _schema = SCHEMA
    _relations = 'define_relations'

    @declared_attr
    def __table_args__(cls):
        return {'schema': cls._schema}


class DbMetadata(Base):
    __tablename__ = 'db_metadata'
    print_fields = ['schema', 'table_name', 'column_name', 'display_name']

    pk = Column(Integer, primary_key=True, server_default=text("nextval('vizdb.db_metadata_pk_seq'::regclass)"))
    schema = Column(Text)
    table_name = Column(Text)
    column_name = Column(Text)
    display_name = Column(Text)
    description = Column(Text)
    unit = Column(Text)
    sql_type = Column(Text)


class SDSSidFlat(Base):
    __tablename__ = 'sdss_id_flat'
    print_fields = ['sdss_id', 'catalogid', 'version_id', 'ra_sdss_id', 'dec_sdss_id']

    sdss_id = Column('sdss_id', BigInteger)
    catalogid = Column('catalogid', BigInteger)
    version_id = Column('version_id', SmallInteger)
    ra_sdss_id = Column('ra_sdss_id', Float(53))
    dec_sdss_id = Column('dec_sdss_id', Float(53))
    n_associated = Column('n_associated', SmallInteger)
    pk = Column('pk', BigInteger, primary_key=True)
    ra_catalogid = Column('ra_catalogid', Float(53))
    dec_catalogid = Column('dec_catalogid', Float(53))


class SDSSidStacked(Base):
    __tablename__ = 'sdss_id_stacked'
    print_fields = ['sdss_id', 'ra_sdss_id', 'dec_sdss_id']

    catalogid21 = Column('catalogid21', BigInteger)
    catalogid25 = Column('catalogid25', BigInteger)
    catalogid31 = Column('catalogid31', BigInteger)
    ra_sdss_id = Column('ra_sdss_id', Float(53))
    dec_sdss_id = Column('dec_sdss_id', Float(53))
    sdss_id = Column('sdss_id', BigInteger, primary_key=True)


class SDSSidToPipes(Base):
    __tablename__ = 'sdssid_to_pipes'
    print_fields = ['sdss_id', 'in_boss', 'in_apogee', 'in_astra']

    pk = Column('pk', BigInteger, primary_key=True)
    sdss_id = Column('sdss_id', BigInteger)
    in_boss = Column('in_boss', Boolean)
    in_apogee = Column('in_apogee', Boolean)
    in_astra = Column('in_astra', Boolean)


def define_relations():
    """ leaving this empty as relations were autogenerated """
    pass


# prepare the base
database.add_base(Base)
